
/*******************************************************************************
  FreeUDFLib function declaration SQL Script for Interbase/Firebird.

  Execute with a script interpreter to define these functions in your database.
*******************************************************************************/

/*******************************************************************************
  Misc functions
*******************************************************************************/
declare external function f_CloseDebuggerOutput
  returns integer by value
  entry_point 'CloseDebuggerOutput' module_name 'FreeUDFLib.dll';

declare external function f_Debug
  cstring(1024)
  returns integer by value
  entry_point 'Debug' module_name 'FreeUDFLib.dll';

declare external function f_IBTempPath
  returns
  cstring(1024) /* free_it */
  entry_point 'IBTempPath' module_name 'FreeUDFLib.dll';

declare external function f_SetDebuggerOutput
  cstring(1024)
  returns integer by value
  entry_point 'SetDebuggerOutput' module_name 'FreeUDFLib.dll';

/*******************************************************************************
  Date/Time functions
*******************************************************************************/
declare external function f_AddMonth
  date,
  integer
  returns
  date /* free_it */
  entry_point 'AddMonth' module_name 'FreeUDFLib.dll';

declare external function f_AddYear
  date,
  integer
  returns
  date /* free_it */
  entry_point 'AddYear' module_name 'FreeUDFLib.dll';

declare external function f_AgeInDays
  date, date
  returns
  integer by value
  entry_point 'AgeInDays' module_name 'FreeUDFLib.dll';

declare external function f_AgeInWeeks
  date, date
  returns
  integer by value
  entry_point 'AgeInWeeks' module_name 'FreeUDFLib.dll';

declare external function f_AgeInMonths
  date, date
  returns
  integer by value
  entry_point 'AgeInMonths' module_name 'FreeUDFLib.dll';

declare external function f_AgeInDaysThreshold
  date, date, integer, integer, integer, integer
  returns
  integer by value
  entry_point 'AgeInDaysThreshold' module_name 'FreeUDFLib.dll';

declare external function f_AgeInWeeksThreshold
  date, date, integer, integer, integer, integer
  returns
  integer by value
  entry_point 'AgeInWeeksThreshold' module_name 'FreeUDFLib.dll';

declare external function f_AgeInMonthsThreshold
  date, date, integer, integer, integer, integer
  returns
  integer by value
  entry_point 'AgeInMonthsThreshold' module_name 'FreeUDFLib.dll';

declare external function f_CDOWLong
  date
  returns cstring(10) /* free_it */
  entry_point 'CDOWLong' module_name 'FreeUDFLib.dll';

declare external function f_CDOWShort
  date
  returns cstring(4) /* free_it */
  entry_point 'CDOWShort' module_name 'FreeUDFLib.dll';

declare external function f_CMonthLong
  date
  returns cstring(10) /* free_it */
  entry_point 'CMonthLong' module_name 'FreeUDFLib.dll';

declare external function f_CMonthShort
  date
  returns cstring(4) /* free_it */
  entry_point 'CMonthShort' module_name 'FreeUDFLib.dll';

declare external function f_DayOfMonth
  date
  returns
  integer by value
  entry_point 'DayOfMonth' module_name 'FreeUDFLib.dll';

declare external function f_DayOfWeek
  date
  returns
  integer by value
  entry_point 'DayOfWeek' module_name 'FreeUDFLib.dll';

declare external function f_DayOfYear
  date
  returns
  integer by value
  entry_point 'DayOfYear' module_name 'FreeUDFLib.dll';

declare external function f_WeekOfYear
  date
  returns
  integer by value
  entry_point 'WeekOfYear' module_name 'FreeUDFLib.dll';

declare external function f_YearOfYear
  date
  returns
  integer by value
  entry_point 'YearOfYear' module_name 'FreeUDFLib.dll';
declare external function f_WOY
  date
  returns
  cstring(254) /* free_it */
  entry_point 'WOY' module_name 'FreeUDFLib.dll';

declare external function f_MaxDate
  date, date
  returns
  date /* free_it */
  entry_point 'MaxDate'
  module_name 'FreeUDFLib.dll';

declare external function f_MinDate
  date, date
  returns
  date /* free_it */
  entry_point 'MinDate'
  module_name 'FreeUDFLib.dll';

declare external function f_StripDate
  date
  returns
  date /* free_it */
  entry_point 'StripDate' module_name 'FreeUDFLib.dll';

declare external function f_StripTime
  date
  returns
  date /* free_it */
  entry_point 'StripTime' module_name 'FreeUDFLib.dll';

/*******************************************************************************
  Math functions
*******************************************************************************/
declare external function f_DollarVal
  double precision
  returns
  cstring(254) /* free_it */
  entry_point 'DollarVal' module_name 'FreeUDFLib.dll';

declare external function f_FixedPoint
  double precision, integer
  returns
  cstring(254) /* free_it */
  entry_point 'FixedPoint' module_name 'FreeUDFLib.dll';

declare external function f_DoubleAbs
  double precision
  returns
  double precision by value
  entry_point 'DoubleAbs' module_name 'FreeUDFLib.dll';

declare external function f_IntegerAbs
  Integer
  returns
  Integer by value
  entry_point 'IntegerAbs' module_name 'FreeUDFLib.dll';

declare external function f_Modulo
  integer, integer
  returns
  integer by value
  entry_point 'Modulo' module_name 'FreeUDFLib.dll';

declare external function f_IsDivisibleBy
  integer, integer
  returns
  integer by value
  entry_point 'IsDivisibleBy' module_name 'FreeUDFLib.dll';

declare external function f_RoundFloat
  double precision,
  double precision
  returns
  double precision by value
  entry_point 'RoundFloat' module_name 'FreeUDFLib.dll';

declare external function f_Truncate
  double precision
  returns integer by value
  entry_point 'Truncate' module_name 'FreeUDFLib.dll';

/*******************************************************************************
  String functions
*******************************************************************************/
declare external function f_Character
  integer
  returns cstring(2) /* free_it */
  entry_point 'Character' module_name 'FreeUDFLib.dll';

declare external function f_CRLF
  returns cstring(3) /* free_it */
  entry_point 'CRLF' module_name 'FreeUDFLib.dll';

declare external function f_Left
  cstring(254), integer
  returns
  cstring(254) /* free_it */
  entry_point 'Left' module_name 'FreeUDFLib.dll';

declare external function f_Mid
  cstring(254), integer, integer
  returns
  cstring(254) /* free_it */
  entry_point 'Mid' module_name 'FreeUDFLib.dll';

declare external function f_Right
  cstring(254), integer
  returns
  cstring(254) /* free_it */
  entry_point 'Right' module_name 'FreeUDFLib.dll';

declare external function f_lTrim
  cstring(254)
  returns
  cstring(254) /* free_it */
  entry_point 'lTrim' module_name 'FreeUDFLib.dll';

declare external function f_rTrim
  cstring(254)
  returns
  cstring(254) /* free_it */
  entry_point 'rTrim' module_name 'FreeUDFLib.dll';

declare external function f_lrTrim
  cstring(254)
  returns
  cstring(254) /* free_it */
  entry_point 'lrTrim' module_name 'FreeUDFLib.dll';

declare external function f_BiglrTrim
  cstring(1024)
  returns
  cstring(1024) /* free_it */
  entry_point 'lrTrim' module_name 'FreeUDFLib.dll';

declare external function f_PadLeft
  cstring(254),
  cstring(10),
  integer
  returns
  cstring(254) /* free_it */
  entry_point 'PadLeft' module_name 'FreeUDFLib.dll';

declare external function f_PadRight
  cstring(254),
  cstring(10),
  integer
  returns
  cstring(254) /* free_it */
  entry_point 'PadRight' module_name 'FreeUDFLib.dll';

declare external function f_FindWord
  cstring(8196),
  integer
  returns cstring(254) /* free_it */
  entry_point 'FindWord' module_name 'FreeUDFLib.dll';

declare external function f_FindWordIndex
  cstring(8196),
  integer
  returns integer by value
  entry_point 'FindWordIndex' module_name 'FreeUDFLib.dll';

declare external function f_ProperCase
  cstring(254)
  returns
  cstring(254) /* free_it */
  entry_point 'ProperCase' module_name 'FreeUDFLib.dll';

declare external function f_StringLength
  cstring(254)
  returns
  integer by value
  entry_point 'StringLength' module_name 'FreeUDFLib.dll';

declare external function f_BigStringLength
  cstring(32760)
  returns
  integer by value
  entry_point 'StringLength' module_name 'FreeUDFLib.dll';

declare external function f_StripString
  cstring(254),
  cstring(254)
  returns
  cstring(254) /* free_it */
  entry_point 'StripString' module_name 'FreeUDFLib.dll';

declare external function f_SubStr
  cstring(254),
  cstring(254)
  returns
  integer by value
  entry_point 'SubStr' module_name 'FreeUDFLib.dll';

declare external function f_BigSubStr
  cstring(1024),
  cstring(1024)
  returns
  integer by value
  entry_point 'SubStr' module_name 'FreeUDFLib.dll';

declare external function f_GenerateSndxIndex
  cstring(256)
  returns
  cstring(6) /* free_it */
  entry_point 'GenerateSndxIndex' module_name 'FreeUDFLib.dll';

/*******************************************************************************
  Blob functions
*******************************************************************************/
declare external function f_BlobSegmentCount
  blob
  returns integer by value
  entry_point 'BlobSegmentCount' module_name 'FreeUDFLib.dll';

declare external function f_BlobMaxSegmentLength
  blob
  returns integer by value
  entry_point 'BlobMaxSegmentLength' module_name 'FreeUDFLib.dll';

declare external function f_BlobSize
  blob
  returns integer by value
  entry_point 'BlobSize' module_name 'FreeUDFLib.dll';

declare external function f_BlobAsPChar
  blob
  returns cstring(32760) /* free_it */
  entry_point 'BlobAsPChar' module_name 'FreeUDFLib.dll';

declare external function f_BlobLeft
  blob, integer
  returns cstring(32760) /* free_it */
  entry_point 'BlobLeft' module_name 'FreeUDFLib.dll';

declare external function f_BlobMid
  blob, integer, integer
  returns cstring(32760) /* free_it */
  entry_point 'BlobMid' module_name 'FreeUDFLib.dll';

declare external function f_BlobRight
  blob, integer
  returns cstring(32760) /* free_it */
  entry_point 'BlobRight' module_name 'FreeUDFLib.dll';

declare external function f_BlobLine
  blob, integer
  returns cstring(1024) /* free_it */
  entry_point 'BlobLine' module_name 'FreeUDFLib.dll';

/*******************************************************************************
  DSI Blob functions
*******************************************************************************/
declare external function F_BlobChecksum
    blob
  returns integer by value
  entry_point 'BlobChecksum' module_name 'FreeUDFLib.dll';

declare external function F_BlobCompare
    blob,
    blob
  returns integer by value
  entry_point 'BlobCompare' module_name 'FreeUDFLib.dll';

declare external function F_BlobBinComp
    blob,
    blob
  returns integer by value
  entry_point 'BlobBinCmp' module_name 'freeudflib.dll';

declare external function F_BlobSearch
    blob,
    cstring(254)
  returns integer by value
  entry_point 'BlobSearch' module_name 'FreeUDFLib.dll';

declare external function F_BlobRTFSearch
    blob,
    cstring(254)
  returns integer by value
  entry_point 'BlobRTFSearch' module_name 'FreeUDFLib.dll';

declare external function f_BlobRTFAsPChar
    blob
  returns cstring(32760) /* free_it */
  entry_point 'BlobRTFasPChar' module_name 'FreeUDFLib.dll';

/*******************************************************************************
  DSI Misc functions
*******************************************************************************/
declare external function F_Hour
    DATE
  returns integer by value
  entry_point 'Hour' module_name 'FreeUDFLib.dll';

declare external function F_HourFromMinute
    integer
  returns integer by value
  entry_point 'HourFromMinute' module_name 'FreeUDFLib.dll';

declare external function F_MinutesRemaining
    integer
  returns integer by value
  entry_point 'MinutesRemaining' module_name 'FreeUDFLib.dll';

declare external function F_NextBirthday
    date
returns date
entry_point 'NextBirthday' module_name 'FreeUDFLib.dll';

declare external function F_IntMax
    integer,
    integer
returns integer by value
entry_point 'IntMax' module_name 'FreeUDFLib.dll';

declare external function F_IntMin
    integer,
    integer
returns integer by value
entry_point 'IntMin' module_name 'FreeUDFLib.dll';

declare external function F_TestBit
    double precision,
    integer
returns integer by value
entry_point 'TestBit' module_name 'FreeUDFLib.dll';

declare external function f_QuoteString
  cstring(254)
  returns
  cstring(254)
  entry_point 'QuoteString' module_name 'FreeUDFLib.dll';
 
/*******************************************************************************
  DSI Proprietary functions
*******************************************************************************/
declare external function f_DTInterval
  date,
  date,
  integer,
  integer,
  integer
  returns
  integer by value
  entry_point 'DTInterval' module_name 'FreeUDFLib.dll';

declare external function f_DTCondInterval
  date,
  date,
  integer,
  integer,
  integer,
  cstring(254),
  cstring(254)
  returns
  integer by value
  entry_point 'DTCondInterval' module_name 'FreeUDFLib.dll';

declare external function f_FormatEmpNameNum
  integer,
  cstring(254),
  cstring(254),
  cstring(254),
  cstring(254),
  cstring(254),
  cstring(254)
  returns
  cstring(254)
  entry_point 'FormatEmpNameNum' module_name 'FreeUDFLib.dll';

declare external function f_PpdSeriesNum
  cstring(254)
  returns
  integer by value
  entry_point 'PpdSeriesNum' module_name 'FreeUDFLib.dll';

declare external function f_PpdSeriesSeqNum
  cstring(254)
  returns
  integer by value
  entry_point 'PpdSeriesSeqNum' module_name 'FreeUDFLib.dll';
